<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler } from "@/utils/apiHanlers";
import AdminCollectionModule from "~/store/adminCollection";
import { api } from "~/common/constaint";
import _ from "lodash";
@Component({})
export default class AdminShopCategoryComponent extends Vue {
  adminCollection = getModule(AdminCollectionModule, this.$store);

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;
  page = 1;

  search = "";

  listFilter = [
    { name: "Filter", value: 0 },
    { name: "Số sản phẩm", value: 10 },
  ];
  filter = 0;

  loadingTable = false;
  loading = false;
  selectedAll = false;

  collectionId = "";
  collectionDeleteId = "";

  dialogDeleteCollection = false;
  dialogDeleteMultipleCollection = false;
  listCollection = [];
  listIds = [];
  async mounted() {
    const { id } = this.$route.params;
    this.collectionId = id || "";
    await this.onGetListCollection();
    // if (id) {
    // 	this.onGetListCollectionChild(id);
    // }
  }

  async onGetListCollection() {
    try {
      this.loadingTable = true;
      const response = await this.$store.dispatch(
        "adminCollection/onGetListCollection",
        {
          ctx: this,
          payload: this.config,
        }
      );
      const { page, total, totalInList, data } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response.data?.data) {
        this.listCollection = response.data.data;
      }
    } catch (error) {
      console.log("error :>> ", error);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogDeleteCollection(collectionId: string) {
    if (collectionId) {
      this.collectionDeleteId = collectionId;
      this.dialogDeleteCollection = true;
    }
  }

  async onDeleteCollection() {
    try {
      this.loading = true;
      await this.$api.collection.delete(this.collectionDeleteId);
      this.$pushNotification.success("Deleted collection successfully");
      this.dialogDeleteCollection = false;
      this.onGetListCollection();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  openDialogDeleteMultipleCollection() {
    if (!this.listIds.length) {
      return this.$pushNotification.error("Please select collection");
    }
    this.dialogDeleteMultipleCollection = true;
  }

  onSearch() {
    this.onGetListCollection();
  }

  convertImage(collection: any) {
    if (collection?.coverId?.imageUrl) {
      const { imageUrl } = collection.coverId;
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListCollection();
  }

  get findNameCollection() {
    const findCollection: any = this.listCollection.find(
      (col: any) => col._id === this.collectionDeleteId
    );
    if (findCollection) {
      return findCollection.name;
    }
    return "";
  }

  @Watch("config.page")
  changedPage() {
    if (this.collectionId) {
      // this.onGetListCollectionChild(this.collectionId);
    } else {
      this.onGetListCollection();
    }
  }

  @Watch("config.search")
  changedSearch(val: string) {
    if (!val) {
      this.onSearch();
    }
  }

  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listIds = [...this.listIds];
      //@ts-ignore
      const selectedCurrentCollection = this.listCollectionViewer
        //@ts-ignore
        .map((collection) => collection._id)
        //@ts-ignore
        .filter((id) => !listIds.includes(id));
      //@ts-ignore
      this.listIds = [...listIds, ...selectedCurrentCollection];
    } else {
      //@ts-ignore
      const selectedCurrentCollection = this.listCollectionViewer
        //@ts-ignore
        .map((collection) => collection._id);
      this.listIds = this.listIds.filter(
        (c) => !selectedCurrentCollection.includes(c)
      );
    }
  }
}
</script>

<style></style>
